       PROGRAM

!Upgraded to 1501 - 1/96

        INCLUDE('Equates.clw')
        INCLUDE('keycodes.clw')

        MAP
          ThreadProc1
          MainMenu
          TimerThread
          BrowseItemsXYZ
          AnotherProc
          TestNonMDI
          NameEvent(LONG),STRING
        END

ShowThread      LONG
ShowEventName   STRING(20),DIM(12),THREAD
TShowEventName  STRING(20),DIM(12),THREAD
Counter         LONG(0),THREAD
TCounter        LONG(0),THREAD

  CODE
  MainMenu

MainMenu    PROCEDURE

ShowEventName1  STRING(20),DIM(12)
ShowMyThread    LONG
Counter1        LONG(0)

MainWin APPLICATION('Application Frame'),AT(0,0,352,201),FONT('Arial',10,,FONT:regular),HVSCROLL,ICON('Compass.ico'), |
         SYSTEM,MAX,MAXIMIZE,RESIZE
       MENUBAR
         ITEM('E&xit !'),USE(?exit),MSG('Exit'),STD(STD:Close)
         ITEM('Thread !'),USE(?Thread1)
         ITEM('Timer Thread !'),USE(?Thread2)
         ITEM('Browse'),USE(?BROWSETheApp)
         MENU('&Window'),USE(?WindowMenu),STD(STD:WindowList)
           ITEM('Tile'),USE(?Tile),STD(STD:TileWindow)
           ITEM('Cascade'),USE(?Cascade),STD(STD:CascadeWindow)
           ITEM,SEPARATOR
         END
       END
       TOOLBAR,AT(0,0,313,22)
         STRING(@s20),AT(1,1,80,10),USE(ShowEventName1[1])
         STRING(@s20),AT(84,1,80,10),USE(ShowEventName1[2])
         STRING(@s20),AT(168,1,80,10),USE(ShowEventName1[3])
         STRING(@s20),AT(1,12,80,10),USE(ShowEventName1[4])
         STRING(@s20),AT(84,12,80,10),USE(ShowEventName1[5])
         STRING(@s20),AT(168,12,80,10),USE(ShowEventName1[6])
         BUTTON('Ok'),AT(252,2,35,19),USE(?Ok)
         BUTTON('Clr'),AT(295,1,16,10),USE(?Clear)
         STRING(@n3),AT(295,12,16,10),USE(ShowMyThread)
       END
     END
DDEChannel  LONG

  CODE
  ShowMyThread = ShowThread
  CLEAR(ShowEventName1)
  OPEN(MainWin)
  ACCEPT
    Counter1 += 1
    IF Counter1 > 6
      CLEAR(ShowEventName1)
      Counter1 = 1
      DISPLAY
    END
    ShowEventName1[Counter1] = NameEvent(EVENT())
    CASE ACCEPTED()
    OF ?Thread1
      ShowThread = START(ThreadProc1)
    OF ?Thread2
      ShowThread = START(TimerThread)
    OF ?BrowseTheApp
      ShowThread = START(BrowseItemsXYZ)
    OF ?OK
      POST(EVENT:LoseFocus,,2)
      POST(EVENT:GainFocus,,3)
    OF ?Clear
      DISPLAY
      CLEAR(ShowEventName1)
      Counter1 = 0
    END
  END
  RETURN


ThreadProc1      PROCEDURE

MakeEvent  LONG,DIM(3)
ListField  STRING(8)
ShowMyThread  LONG
SpinNumber  LONG
Option1 String(3)

Label WINDOW('Event Test Window'),AT(58,11,202,166),FONT('Arial',10,,FONT:regular),ALRT(F10Key),SYSTEM, |
         GRAY,MAX,MDI
       BOX,AT(4,4,80,160)
       STRING(@s20),AT(6,6,74,10),USE(ShowEventName[1])
       STRING(@s20),AT(6,19,74,10),USE(ShowEventName[2])
       STRING(@s20),AT(6,32,74,10),USE(ShowEventName[3])
       STRING(@s20),AT(6,45,74,10),USE(ShowEventName[4])
       STRING(@s20),AT(6,59,74,10),USE(ShowEventName[5])
       STRING(@s20),AT(6,72,74,10),USE(ShowEventName[6])
       STRING(@s20),AT(6,85,74,10),USE(ShowEventName[7])
       STRING(@s20),AT(6,98,74,10),USE(ShowEventName[8])
       STRING(@s20),AT(6,111,74,10),USE(ShowEventName[9])
       STRING(@s20),AT(6,125,74,10),USE(ShowEventName[10])
       STRING(@s20),AT(6,139,74,10),USE(ShowEventName[11])
       STRING(@s20),AT(6,153,74,10),USE(ShowEventName[12])
       BUTTON('&Ok'),AT(125,114),USE(?Ok)
       BUTTON('&Clear'),AT(125,137,32,14),USE(?Clear)
       STRING('Thread:'),AT(149,154),USE(?String14)
       STRING(@n3),AT(180,154,17,10),USE(ShowMyThread)
       SHEET,AT(88,4,109,100),USE(?Sheet1)
         TAB('Tab &1'),USE(?Tab1)
           PROMPT('Field &One:'),AT(110,32)
           ENTRY(@n4),AT(152,31),USE(MakeEvent[1])
           ENTRY(@n4),AT(152,50),USE(MakeEvent[2]),IMM
           PROMPT('Field &Two:'),AT(110,51,38,10)
           ENTRY(@n4),AT(152,70),USE(MakeEvent[3])
           PROMPT('Field T&hree:'),AT(105,71,43,10)
         END
         TAB('Tab &2'),USE(?Tab2)
           PROMPT('&List'),AT(93,22)
           LIST,AT(94,34,98,59),USE(ListField),IMM,VSCROLL,VCR,FROM('Gilberto|Nivia|Carmen|Adrian|Carlos|Antonio')
         END
         TAB('Spin'),USE(?Tab3)
           CHECK('Check 1'),AT(101,21),USE(Check1#)
           SPIN(@t3),AT(102,35,65,12),USE(SpinNumber),RANGE(0,8260000),STEP(60000)
           OPTION('Option 1'),AT(102,53,71,38),USE(Option1),BOXED
             RADIO('Yes'),AT(109,62),USE(?Option1:Radio1)
             RADIO('No'),AT(109,76),USE(?Option1:Radio2)
           END
         END
       END
     END
  CODE
  ShowMyThread = ShowThread
  OPEN(Label)
  ACCEPT
    CASE EVENT()
        OF Event:GainFocus
          Label{PROP:ACTIVE} = 1
        OF Event:Selected
        CASE FIELD()
        OF ?MakeEVENT_3
          ?MakeEvent_3{PROP:Touched} = 1
        END
      END

    Counter += 1
    IF Counter > 12
      CLEAR(ShowEventName)
      Counter = 1
    END
    ShowEventName[Counter] = NameEvent(EVENT())
    CASE ACCEPTED()
      OF ?Clear
      CLEAR(ShowEventName)
      Counter = 0
    END
    DISPLAY
  END


TimerThread      PROCEDURE

ShowMyThread  LONG
TimeShow        LONG

Label WINDOW('Timer Test Window'),AT(89,4,123,166),FONT('Courier New',10,,FONT:regular),TIMER(500),SYSTEM, |
         MAX,MDI
       STRING(@s20),AT(5,6,74,10),USE(TShowEventName[1])
       STRING(@s20),AT(5,19,74,10),USE(TShowEventName[2])
       STRING(@s20),AT(5,32,74,10),USE(TShowEventName[3])
       STRING(@s20),AT(5,45,74,10),USE(TShowEventName[4])
       STRING(@s20),AT(5,59,74,10),USE(TShowEventName[5])
       STRING(@s20),AT(5,72,74,10),USE(TShowEventName[6])
       STRING(@s20),AT(5,85,74,10),USE(TShowEventName[7])
       STRING(@s20),AT(5,98,74,10),USE(TShowEventName[8])
       STRING(@s20),AT(5,111,74,10),USE(TShowEventName[9])
       STRING(@s20),AT(5,125,74,10),USE(TShowEventName[10])
       STRING(@s20),AT(5,139,74,10),USE(TShowEventName[11])
       STRING(@s20),AT(5,153,74,10),USE(TShowEventName[12])
       STRING(@t4),AT(84,6,38,10),USE(TimeShow),RIGHT
       STRING(@n3),AT(109,156,15,10),USE(ShowMyThread)
     END
  CODE
  ShowMyThread = ShowThread
  OPEN(Label)
  ACCEPT
    TCounter += 1
    IF TCounter > 12
      CLEAR(TShowEventName)
      TCounter = 1
    END
    TShowEventName[TCounter] = NameEvent(EVENT())
    IF EVENT() = EVENT:Timer
      TimeShow = CLOCK()
    END
  END


BrowseItemsXYZ     Procedure

StringDisplay  STRING(20)

BrowseWin WINDOW('An MDI Window'),AT(44,11,180,76),FONT('Arial',10,,FONT:bold),COLOR(0A8EAFBH),SYSTEM, |
         MAX,MDI
       STRING('Hi'),AT(1,0,10,10),USE(?StringField)
       STRING(@s20),AT(51,6,83,10),USE(StringDisplay)
       BUTTON('Ok'),AT(32,47,30,19),USE(?Ok),DEFAULT
       BUTTON('Cancel'),AT(118,47,30,19),USE(?Cancel)
     END
Code4Entry  STRING(10)
X   SHORT
Y   SHORT
Width   SHORT
Height  SHORT

  CODE
  OPEN(BrowseWin)
  ACCEPT
    CASE ACCEPTED()
    OF ?Ok
      AnotherProc
    Of ?Cancel
      Break
    END
    StringDisplay = NameEvent(EVENT())
    DISPLAY
  END
  CLOSE(BrowseWin)

AnotherProc     Procedure

StringDisplay  STRING(20)

BrowseWin WINDOW('Another MDI Window'),AT(102,5,133,59),COLOR(0FEC5CEH),SYSTEM,MAX,MDI
       STRING('Hi'),AT(1,0,10,10),USE(?StringField)
       STRING(@s20),AT(25,14,83,10),USE(StringDisplay)
       BUTTON('Ok'),AT(0,40,30,19),USE(?Ok),DEFAULT
       BUTTON('Cancel'),AT(103,40,30,19),USE(?Cancel)
     END

  Code

  OPEN(BrowseWin)
  ACCEPT
    CASE ACCEPTED()
    OF ?Ok
      TestNonMDI
    OF ?Cancel
      Break
    END
    StringDisplay = NameEvent(EVENT())
    DISPLAY
  END
  CLOSE(BrowseWin)

TestNonMDI  PROCEDURE
StringDisplay  STRING(20)

!Force Change

BrowseWin WINDOW('Application Modal'),AT(30,5,151,50),COLOR(0E2D6FEH),MAX,RESIZE
       STRING('Hi'),AT(1,0,10,10),USE(?StringField)
       STRING(@s20),AT(34,14,,10),USE(StringDisplay)
       BUTTON('Ok'),AT(0,31,30,19),USE(?Ok),DEFAULT
       BUTTON('Cancel'),AT(121,31,30,19),USE(?Cancel)
     END

  CODE

  OPEN(BrowseWin)
  ACCEPT
    CASE ACCEPTED()
    OF ?Cancel
      Break
    END
    StringDisplay = NameEvent(EVENT())
    DISPLAY
  END
  CLOSE(BrowseWin)


NameEvent   FUNCTION(EventNumber)

ReturnString  STRING(20)
  CODE
  CASE EventNumber
  OF 01H
    ReturnString = 'EVENT:Accepted'
  OF 02H
    ReturnString = 'EVENT:NewSelection'
  OF 03H
    ReturnString = 'EVENT:ScrollUp'
  OF 04H
    ReturnString = 'EVENT:ScrollDown'
  OF 05H
    ReturnString = 'EVENT:PageUp'
  OF 06H
    ReturnString = 'EVENT:PageDown'
  OF 07H
    ReturnString = 'EVENT:ScrollTop'
  OF 08H
    ReturnString = 'EVENT:ScrollBottom'
  OF 09H
    ReturnString = 'EVENT:Locate'
  OF 01H
    ReturnString = 'EVENT:MouseDown'
  OF 0aH
    ReturnString = 'EVENT:MouseUp'
  OF 0bH
    ReturnString = 'EVENT:MouseIn'
  OF 0cH
    ReturnString = 'EVENT:MouseOut'
  OF 0dH
    ReturnString = 'EVENT:MouseMove'
  OF 0eH
    ReturnString = 'EVENT:VBXevent'
  OF 0fH
    ReturnString = 'EVENT:AlertKey'
  OF 10H
    ReturnString = 'EVENT:PreAlertKey'
  OF 11H
    ReturnString = 'EVENT:Dragging'
  OF 12H
    ReturnString = 'EVENT:Drag'
  OF 13H
    ReturnString = 'EVENT:Drop'
  OF 14H
    ReturnString = 'EVENT:ScrollDrag'
  OF 15H
    ReturnString = 'EVENT:TabChanged'
  OF 1AH
    ReturnString = 'EVENT:Rejected'
  OF 1DH
    ReturnString = 'EVENT:ScrollTrack'
  OF 101H
    ReturnString = 'EVENT:Selected'
  OF 201H
    ReturnString = 'EVENT:CloseWindow'
  OF 202H
    ReturnString = 'EVENT:CloseDown'
  OF 203H
    ReturnString = 'EVENT:OpenWindow'
  OF 204H
    ReturnString = 'EVENT:OpenFailed'
  OF 205H
    ReturnString = 'EVENT:LoseFocus'
  OF 206H
    ReturnString = 'EVENT:GainFocus'
  OF 208H
    ReturnString = 'EVENT:Suspend'
  OF 209H
    ReturnString = 'EVENT:Resume'
  OF 20AH
    ReturnString = 'EVENT:Notify'
  OF 20BH
    ReturnString = 'EVENT:Timer'
  OF 20CH
    ReturnString = 'EVENT:DDErequest'
  OF 20DH
    ReturnString = 'EVENT:DDEadvise'
  OF 20EH
    ReturnString = 'EVENT:DDEdata'
  OF 20FH
    ReturnString = 'EVENT:DDEcommand'
  OF 210H
    ReturnString = 'EVENT:Move'
  OF 211H
    ReturnString = 'EVENT:Size'
  OF 212H
    ReturnString = 'EVENT:Restore'
  OF 213H
    ReturnString = 'EVENT:Maximize'
  OF 214H
    ReturnString = 'EVENT:MInimize'
  OF 215H
    ReturnString = 'EVENT:Completed'
  OF 400H TO 0FFFH
    ReturnString = EventNumber & ' - User Defined EVENT'
  ELSE
    ReturnString = EventNumber & ' - Unknown EVENT'
  END
  RETURN(ReturnString)
